/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/34101*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */
/* Andy Wallace
 * Particle Letters
 * 2010
 *
 * 
 */

//Particle2[] particles3=new Particle2[0];
int ShowDepth2;
int skip = 3; //work on every 3rdd pixel - reduces processing time
ArrayList<Particle2> particles3 = new ArrayList<Particle2>();
int partlength1;
float lifelength = 10000; //in frames
void setup8(){
  size(640,520,OPENGL);
  //hint(ENABLE_NATIVE_FONTS);
  frameRate(30);
  //noCursor();
  smooth(); 
  free=false;
  pAccel=.09;  //acceleration rate of the particles
  pMaxSpeed=9;
  kinect.enableColorDepth(false);
}

void draw8(){
  
  tracker.track();
  if (ShowDepth2==0){
    tracker.display();
    background(0);
  } else {
    background(0);
    tracker.display();
  }
  
  int c=0;
  
  for (int x1=0; x1<kinect.width; x1=x1+skip){
    for (int y1=0; y1<kinect.height; y1=y1+skip){
      if (tracker.display.pixels[GetPixel(x1,y1)] == color(150, 50, 50)){
        if(c>=particles3.size()){
          particles3.add(new Particle2(x1,y1,lifelength));
        } else {
          Particle2 part = particles3.get(c);
          part.xGoal = x1;
          part.yGoal = y1; 
        }
        c++; 
      } else {
        //here we could check for another color on the depth layer if one was configured.
      }
    }
  }
  
  partlength1 = particles.size();
    
  for (int s=c;s<particles3.size(); s++){
      Particle2 thispart = particles3.get(s);
      thispart.xGoal = width/2;
      thispart.yGoal = height+100;
  }
    
  for (int ps=0;ps<particles3.size();ps++){
    Particle2 thispart = particles3.get(ps);
    if(thispart.isDead()||((thispart.lifespan<thispart.lifespan/5)&&(thispart.y<0))){
        particles3.remove(ps);
    } else {
      thispart.Update();
    }
  }
 server.sendScreen();
}
void toggleDepth2() {
  if(ShowDepth2 != 0)
    ShowDepth2 = 0;
  else
    ShowDepth2 = 1;
}
