/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/81546*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */
// The next line is needed if running in JavaScript Mode with Processing.js
/* @pjs preload="moon-wide.jpg"; */ 

PImage img;
PVector v1d;
PVector v2d; 
void setup3() {
  size(640, 520,OPENGL);
  background(0);
  smooth();
  frameRate(60);
  v1d = tracker.getPos();
  v2d = tracker.getLerpedPos();
  img = loadImage("../ImageTorch/alicebackground.jpg");
  img.loadPixels();
  // Only need to load the pixels[] array once, because we're only
  // manipulating pixels[] inside draw(), not drawing shapes.
  loadPixels();
}

void draw3() {
  
  tracker.track();
  v1d = tracker.getPos();
  v2d = tracker.getLerpedPos();
  for (int x = 0; x < img.width; x++) {
    for (int y = 0; y < img.height; y++ ) {
      // Calculate the 1D location from a 2D grid
      int loc = x + y*img.width;
      // Get the R,G,B values from image
      float r,g,b;
      r = red (img.pixels[loc]);
      g = green (img.pixels[loc]);
      b = blue (img.pixels[loc]);
      // Calculate an amount to change brightness based on proximity to the mouse
      float maxdist = 50;//dist(0,0,width,height);
      float d = dist(x, y, v1d.x, v1d.y);
      float adjustbrightness = 175*(maxdist-d)/maxdist;
      r += adjustbrightness;
      //g += adjustbrightness;
      //b += adjustbrightness;
      // Constrain RGB to make sure they are within 0-255 color range
      r = constrain(r, 0, 255);
      g = constrain(g, 50, 100);
      b = constrain(b, 0, 0);
      // Make a new color and set pixel in the window
      //color c = color(r, g, b);
      color c = color(r);
      pixels[y*width + x] = c;
    }
  }
  updatePixels();
  server.sendScreen();
}

// Brightness by Daniel Shiffman.
//code for this sketch is from: http://processing.org/learning/topics/brightness.html
//image from: http://www.fanpop.com/spots/alice-in-wonderland/images/1759209/title/alice-wonderland-1951-screencap
