/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/34101*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */
/* Andy Wallace
 * Particle Letters
 * 2010
 *
 * Click to have the particles form the word
 */
 
ArrayList<Particle2> particles2 = new ArrayList<Particle2>();
boolean free=true;  //when this becomes false, the particles move toward their goals
int timer;
float pAccel=.06;  //acceleration rate of the particles
float pMaxSpeed=4;  //max speed the particles can move at

color bgColor=color(0);

//PGraphics words;  //holds the image container the words
color testColor=color(255);  //the color we will check for in the image. Currently black
int partlength=0;
int wcnt = 0;
void setup7(){
  size(640,520,OPENGL);
  //hint(ENABLE_NATIVE_FONTS);
  timer = millis() + 4000;
  frameRate(30);
  //noCursor();
  smooth(); 
}

void trigger7(){
  //go through the image, find all black pixel and create a particle for them
  //start by drawing the background and the image to the screen
  
  words = createGraphics(640,520);
  int wordslength = wordlist.length;
  String theword = wordlist[wcnt];
  wcnt++;
  words.beginDraw();
  words.background(0);
  words.fill(255,255,255);
  words.textFont(createFont("Arial", 72));
  float w = words.textWidth(theword);
  float mywidth = (width-w)-40;
  float myheight = height-40;
  words.text(theword,random(40,mywidth),random(40,myheight));
  words.endDraw();
  words.updatePixels();  
  //go through the entire array of pixels, creating a particle for each black pixel
  int c=0;
  for (int x1=0; x1<width; x1++){
    for (int y1=0; y1<height; y1++){
      if (words.pixels[GetPixel(x1,y1)] == testColor){
        if(c>=partlength){
          particles2.add(new Particle2(x1,y1,500));
        } else {
          Particle2 part = particles2.get(c);
          part.xGoal = x1;
          part.yGoal = y1;
        }
        c++;
      }
    }
  }
  
  for (int s=c;s<particles2.size(); s++){
    Particle2 part = particles2.get(s);
    float ls = part.lifespan;
    
    part.xGoal = width/2;
    part.yGoal = height+100;
    
    //println(particles2.length);
  }
  for (int ps=0;ps<particles2.size();ps++){
    Particle2 thispart = particles2.get(ps);
    if(thispart.isDead()){
      if(thispart.x<0||thispart.x>kinect.width||thispart.y<0||thispart.y>kinect.height){
        particles2.remove(ps); //we remove dead particles the next time they move off-screen
      }
    }
  }
  
  partlength=particles2.size();
  //println(partlength);
  if (wcnt==wordlist.length){
   wcnt=0;
  }
}

void draw7(){
  background(0);
  
  for (int i=0; i<particles2.size(); i++){
    Particle2 part1 = particles2.get(i);
    /*if (part1.y<0){
      
    }*/
    part1.Update();
  }
  
  if(millis() >= timer){
    if(free==false){
      timer = millis() + 3500;
    } else {
      timer = millis()+13000;
    }
    flip();
  }
 server.sendScreen();
}
void flip(){
  if (free == true) {
    free=false;
  } else {
    free=true;trigger7();
  }
}

void mousePressed(){
  if (free == true) {
    free=false;
  } else {
    free=true;trigger7();
  }
}

//returns the locaton in pixels[] of the point (x,y)
int GetPixel(int x2, int y2) {
  return(x2+y2*width);
}

String[] wordlist = {
  "particles",
  "interaction",
  "typography"
};
 
